/*
 * gsampler-database.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_DATABASE_H_
#define _GSAMPLER_DATABASE_H_

#include <gtk/gtk.h>
#include "gsampler-database-progress.h"

G_BEGIN_DECLS

#define GSAMPLER_TYPE_DATA_BASE (gsampler_data_base_get_type ())
#define GSAMPLER_DATA_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_DATA_BASE, GsamplerDataBase))
#define GSAMPLER_DATA_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_DATA_BASE, GsamplerDataBaseClass))
#define GSAMPLER_IS_DATA_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_DATA_BASE))
#define GSAMPLER_IS_DATA_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_DATA_BASE))
#define GSAMPLER_DATA_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_DATA_BASE, GsamplerDataBaseClass))
#define GSAMPLER_DATA_BASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_DATA_BASE, GsamplerDataBasePrivate))

typedef struct _GsamplerDataBase GsamplerDataBase;
typedef struct _GsamplerDataBaseClass GsamplerDataBaseClass;
typedef struct _GsamplerDataBasePrivate GsamplerDataBasePrivate;

struct _GsamplerDataBase {
	GtkBox parent_instance;
	GsamplerDataBasePrivate * priv;
};

struct _GsamplerDataBaseClass {
	GtkBoxClass parent_class;
};

struct _GsamplerDataBasePrivate {
	GtkTreeView *db_tree;
	GtkTreeView *inst_tree;
	GsamplerDatabaseProgress *db_progress;
	GtkTreeIter current_iter;
	
	gint add_job_id;
	gint coun_sig_id;
	gint chan_id;
	gchar *new_rep;
	gchar *move_inst;
	gchar *move_dst;
	gchar *move_action;
};

GType gsampler_data_base_get_type (void) G_GNUC_CONST;
GsamplerDataBase* gsampler_data_base_new (void);

void gsampler_data_base_active (GsamplerDataBase* self);
void gsampler_data_base_inactive (GsamplerDataBase* self);

G_END_DECLS

#endif /* _GSAMPLER_DATABASE_H_ */