/*
 * gsampler-midi-map.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 
#ifndef _GSAMPLER_MIDI_MAP_H_
#define _GSAMPLER_MIDI_MAP_H_

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GSAMPLER_TYPE_MIDI_MAP (gsampler_midi_map_get_type ())
#define GSAMPLER_MIDI_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_MIDI_MAP, GsamplerMidiMap))
#define GSAMPLER_MIDI_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_MIDI_MAP, GsamplerMidiMapClass))
#define GSAMPLER_IS_MIDI_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_MIDI_MAP))
#define GSAMPLER_IS_MIDI_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_MIDI_MAP))
#define GSAMPLER_MIDI_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_MIDI_MAP, GsamplerMidiMapClass))
#define GSAMPLER_MIDI_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_MIDI_MAP, GsamplerMidiMapPrivate))

typedef struct _GsamplerMidiMap GsamplerMidiMap;
typedef struct _GsamplerMidiMapClass GsamplerMidiMapClass;
typedef struct _GsamplerMidiMapPrivate GsamplerMidiMapPrivate;

struct _GsamplerMidiMap {
	GtkBox parent_instance;
	GsamplerMidiMapPrivate * priv;
};

struct _GsamplerMidiMapClass {
	GtkBoxClass parent_class;
};

struct _GsamplerMidiMapPrivate {
	GtkTreeView* map_tree;
	GtkTreeView* inst_tree;
	GtkTreeIter current_iter;
	GtkButton* inst_button;
	GtkButton* del_map_button;
	GtkButton* edit_map_button;
	GtkButton* add_map_button;
};

GType 				gsampler_midi_map_get_type (void) G_GNUC_CONST;
GsamplerMidiMap* 	gsampler_midi_map_get_instance (void);
GsamplerMidiMap* 	gsampler_midi_map_new (void);

void 				gsampler_midi_map_active (GsamplerMidiMap* self);
void 				gsampler_midi_map_inactive (GsamplerMidiMap* self);
gboolean 			gsampler_midi_map_delete_all_map (GsamplerMidiMap* self);
GSList * 			gsampler_midi_map_get_midi_maps (void);

G_END_DECLS

#endif /* _GSAMPLER_MIDI_MAP_H_ */
